' PROGRAM Liberty Flame
REM Written by ZE OLIVEIRA
REM Language: Pascalated BASIC
REM Compiler: Boriel ZX BASIC
REM (c) Zarsoft 2023 

'#include <input.bas>  ' number = VAL INPUT(12)
'#include <screen.bas> ' SCREEN$ function
#include <attr.bas>   ' ATTR function

'--- Pascalated Boriel ---
#define PROGRAM   REM
#define BEGIN REM
'#define CONST     CONST
#define VAR       DIM
#define INTEGER   LONG
#define REAL      FLOAT
#define CHAR      STRING ' UBYTE is type integer
'#define STRING    STRING
#define BOOLEAN   UBYTE
#define TYPE      AS
'#define WHILE    WHILE
#define REPEAT    DO
#define UNTIL     LOOP UNTIL
#define PROCEDURE  SUB
#define ORD        CODE
'#define MOD        MOD
CONST   TRUE      TYPE BOOLEAN = 1 
CONST   FALSE     TYPE BOOLEAN = 0 


PROGRAM Liberty Flame

REM CONSTant declarations
CONST LEFT = -1
CONST RIGHT = 1
CONST Period = 10      ' for game speed
CONST BurnTime = 6     ' for fuel burn speed = ROUND(46/8)
CONST BarrelTime = 48  ' for new barrels (max = 8*Burntime)
' 1 trek = 46 steps

REM VAR - Global variables
VAR LIN,COL TYPE INTEGER
VAR HEADING TYPE INTEGER ' -1 left, 1 right
VAR LOADED TYPE BOOLEAN
VAR GameOver TYPE BOOLEAN
VAR Fuel TYPE INTEGER
VAR BurnClock TYPE INTEGER
VAR BarrelClock TYPE INTEGER
VAR Score,MaxScore TYPE INTEGER
VAR BIKES TYPE INTEGER

'--- KEYBOARD BUFFER ---

VAR LASTKEY$ TYPE STRING = ""

PROCEDURE ScanKey
VAR key$ TYPE STRING = INKEY$ + "#"
IF key$(0) <> "#" 
  IF key$(0) <> LASTKEY$ THEN LASTKEY$ = key(0)
ENDIF
END PROCEDURE

FUNCTION LastKey$ TYPE STRING
RETURN LASTKEY$
END FUNCTION

'------------------------

VAR Clock,Clock0 TYPE INTEGER

PROCEDURE WaitClock
VAR elapsed TYPE INTEGER
REPEAT
  ScanKey
  LET Clock = PEEK 23672
  LET elapsed = Clock-Clock0
  IF elapsed<0 THEN LET elapsed = elapsed+256
UNTIL elapsed >= Period
LET Clock0 = Clock0 + Period: IF Clock0 > 255 THEN LET Clock0 = Clock0 - 256
REM PRINT AT 0,0;INK 2;elapsed;"  ";
END PROCEDURE

'------------------------

PROCEDURE DeleteBike
IF HEADING = LEFT ' bike left
  PRINT AT LIN,COL;  "   ";
  PRINT AT LIN+1,COL;"    ";
ELSE ' bike right
  PRINT AT LIN,COL+1; "   ";
  PRINT AT LIN+1,COL;"    ";
ENDIF
END PROCEDURE

PROCEDURE PrintBike
IF HEADING = LEFT ' bike left
  IF LOADED 
    PRINT AT LIN,COL;  "\{i5}\J\{i6}\L\{i2}\T";
    PRINT AT LIN+1,COL;"\{i5}\K\{p5}\{i6}\M\{i5}\::\{p1}\{i5}\N";
  ELSE 
    PRINT AT LIN,COL;  "\{i5}\J\{i6}\L ";
    PRINT AT LIN+1,COL;"\{i5}\K\{p5}\{i6}\M\{i5}\::\{p1}\{i5}\N";
  ENDIF
ELSE ' bike right
  IF LOADED 
    PRINT AT LIN,COL+1;"\{i2}\T\{i6}\P\{i5}\R";
    PRINT AT LIN+1,COL;"\{p1}\{i5}\O\{i5}\::\{p5}\{i6}\Q\{p1}\{i5}\S";
  ELSE 
    PRINT AT LIN,COL+1;" \{i6}\P\{i5}\R";
    PRINT AT LIN+1,COL;"\{p1}\{i5}\O\{i5}\::\{p5}\{i6}\Q\{p1}\{i5}\S";
  ENDIF  
ENDIF
END PROCEDURE

'------------------------

PROCEDURE Crash
VAR i TYPE INTEGER
PRINT AT 17,3;FLASH 1;"You crashed into the pier!"
FOR i = -10 TO 5
  BEEP .005,i+10
  DeleteBike
  BEEP .005,ABS i
  PrintBike
NEXT i
GameOver = TRUE
END PROCEDURE

PROCEDURE OutOfFuel
VAR i TYPE INTEGER
PRINT AT 0,28;PAPER 0;INK 6;" "
PRINT AT 17,3;FLASH 1;"The liberty flame"
PRINT AT 18,3;FLASH 1;"run out of fuel!"
FOR i = -10 TO 5
  BEEP .005,i+10
  DeleteBike
  BEEP .005,ABS i
  PrintBike
NEXT i
GameOver = TRUE
END PROCEDURE

PROCEDURE Finalization
IF MaxScore < Score THEN MaxScore = Score
PRINT AT 23,0;PAPER 0;INK 2;"Press any key to try again";
PAUSE 1
PAUSE 1
PAUSE 0
END PROCEDURE

'------------------------

PROCEDURE AddScore
Score = Score+1
PRINT AT 15,0;" Score: ";Score;TAB 15;"MaxScore: ";MaxScore;TAB 0; 
END PROCEDURE

PROCEDURE AddBarrel
VAR l,c TYPE INTEGER
BarrelClock = BarrelClock-1
IF BarrelClock = 0
  l = 1+INT(8*RND)
  c = 10-l
  PRINT AT l,c;PAPER 7;INK 2;"\T"
  BarrelClock = BarrelTime
ENDIF  
END PROCEDURE

PROCEDURE AddFuel
VAR y TYPE INTEGER
FOR y=7 TO 0 STEP -1
  REM delete barrel
  PLOT INVERSE 1;PAPER 1;INK 2;26*8,14*8+y
  DRAW INVERSE 1;PAPER 1;INK 2;8,0
  REM fill up
  IF Fuel < 8*4
    Fuel = Fuel+1
    PLOT 28*8,14*8+Fuel-1
    DRAW PAPER 0;INK 2;2*8-1,0
    BEEP .03,Fuel
  ENDIF
NEXT y
END PROCEDURE

PROCEDURE SubFuel
BurnClock = BurnClock-1
IF BurnClock = 0
  'PRINT AT 0,0;Fuel;" ";14*8+Fuel-1;" ";
  PLOT INVERSE 1;PAPER 0;INK 2;28*8,14*8+Fuel-1
  DRAW INVERSE 1;PAPER 0;INK 2;2*8-1,0
  Fuel = Fuel-1
  BurnClock = BurnTime
  IF Fuel < 1 THEN OutOfFuel
ENDIF  
END PROCEDURE

'------------------------

PROCEDURE KeyUp
IF LIN > 1 
  'PRINT AT 0,0;ATTR(LIN-1,COL);
  IF (HEADING = LEFT AND ATTR(LIN-1,COL) <> 7+1*8) OR ( HEADING = RIGHT AND ATTR(LIN,COL) <> 7+1*8 )
    Crash
  ELSE
    DeleteBike
    LIN = LIN-1
    PrintBike
    BEEP .01,20*RND
  ENDIF  
ENDIF
END PROCEDURE

PROCEDURE KeyDown
IF LIN < 12
  DeleteBike
  LIN = LIN+1
  PrintBike
  BEEP .01,20*RND
ENDIF
END PROCEDURE

PROCEDURE KeyLeft
'PRINT AT 0,0;ATTR(LIN,COL);
IF (HEADING = LEFT AND ATTR(LIN,COL-1) <> 7+1*8) OR ( HEADING = RIGHT AND ATTR(LIN+1,COL-1) <> 7+1*8 )
    Crash
ELSE
  DeleteBike
  COL = COL-1
  PrintBike
  BEEP .01,20*RND
ENDIF  
END PROCEDURE

PROCEDURE KeyRight
'PRINT AT 20,0;LIN;" ";COL;"  ";
IF LIN=9 AND COL=22
  Crash
ELSEIF COL < 22
  DeleteBike
  COL = COL+1
  PrintBike
  BEEP .01,20*RND
ENDIF  
END PROCEDURE

PROCEDURE KeyTurn
'PRINT AT 0,0;ATTR(LIN,COL);" ";ATTR(LIN+1,COL+4);"  ";
IF HEADING = LEFT OR ( HEADING = RIGHT AND ATTR(LIN,COL) = 7+1*8 )
  DeleteBike
  HEADING = -HEADING
  PrintBike
  BEEP .01,20*RND: BEEP .01,20*RND: BEEP .01,20*RND: BEEP .01,20*RND: 
ENDIF  
LASTKEY$ = "!"
END PROCEDURE

PROCEDURE KeyTake
'PRINT AT 0,0;ATTR(LIN,COL);" ";ATTR(LIN+1,COL+4);"  ";
IF NOT LOADED AND HEADING = RIGHT AND ATTR(LIN,COL) = 2+7*8
  PRINT AT LIN,COL;PAPER 7;" ";
  LOADED = TRUE
  PrintBike
  BEEP .01,0: BEEP .02,20
ENDIF  
LASTKEY$ = "!"
END PROCEDURE

PROCEDURE KeyDrop
'PRINT AT 0,0;ATTR(LIN,COL);" ";ATTR(LIN+1,COL+4);"  ";
IF LOADED AND HEADING = LEFT AND ATTR(LIN+1,COL+4) = 7+4*8
  LOADED = FALSE
  PrintBike
  PRINT AT LIN,COL+4;PAPER 1;INK 2;"\T";
  AddFuel
  BEEP .01,20: BEEP .02,0
ENDIF  
LASTKEY$ = "!"
END PROCEDURE

PROCEDURE KeyTakeDrop
IF COL < 15 
  KeyTake
ELSE  
  KeyDrop
ENDIF  
END PROCEDURE

'------------------------

PROCEDURE InitScreen
VAR i TYPE INTEGER
BORDER 0 : PAPER 0: INK 7: CLS
REM play zone
BORDER 0 : PAPER 1: INK 7
PRINT AT 1,0;
FOR i = 1 TO 13
  PRINT " ";TAB 0;
NEXT i
REM Title
PRINT AT 0,10;PAPER 0;INK 4;" LIBERTY FLAME "
REM Piers
PRINT PAPER 7;"          "
PRINT PAPER 7;"         "
PRINT PAPER 7;"        "
PRINT PAPER 7;"       "
PRINT PAPER 7;"      "
PRINT PAPER 7;"     "
PRINT PAPER 7;"    "
PRINT PAPER 7;"   "
PRINT PAPER 7;"  "
PRINT PAPER 7;" "
PRINT PAPER 7;" "
PRINT PAPER 7;" "
PRINT PAPER 7;" "
REM Liberty Statue
PRINT AT 1,28;"\A"
PRINT AT 2,28;"\B\F"
PRINT AT 3,28;"\C\G"
PRINT AT 4,28;"\D\H"
PRINT AT 5,28;"\E\I"
PRINT AT 6,28;PAPER 0;"  "
PRINT AT 7,28;PAPER 0;"  "
PRINT AT 8,28;PAPER 0;"  "
PRINT AT 9,28;PAPER 0;"  "
PRINT AT 10,26;PAPER 4;"      "
REM FuelLevel
FOR i=1 TO 4
  AddFuel
NEXT i  
BurnClock = BurnTime
REM Flame
PRINT AT 0,28;PAPER 0;INK 6;"\U"
REM Bike
PrintBike
REM reset clock after fillup time
LET Clock0 = PEEK 23672
END PROCEDURE

PROCEDURE InitGame
LET LIN = 9
LET COL = 22
LET HEADING = LEFT
LET LOADED = FALSE
LET GameOver = FALSE
LET Fuel = 0
LET BarrelClock = BarrelTime
LET Score = 0
LET BIKES = 3
RANDOMIZE
END PROCEDURE

'------------------------

PROCEDURE Game
InitGame
InitScreen
REPEAT 
  AddScore
  SubFuel
  AddBarrel
  LASTKEY$ = "!"
  WaitClock
  IF LASTKEY$ = "q" THEN KeyUp
  IF LASTKEY$ = "a" THEN KeyDown
  IF LASTKEY$ = "o" THEN KeyLeft
  IF LASTKEY$ = "p" THEN KeyRight
  IF LASTKEY$ = "m" OR LASTKEY$ = " " THEN KeyTurn
  IF LASTKEY$ = "1" THEN KeyTakeDrop
UNTIL GameOver
Finalization
END PROCEDURE

'------------------------

PROCEDURE Introduction
'PAUSE 0
BORDER 0 : PAPER 0: INK 7: CLS
PRINT AT 0,5;PAPER 4;INK 0;" LIBERTY FLAME "
PRINT
PRINT "Keep the flame of freedom alive."
PRINT
PRINT INK 6;"Keys:"
PRINT
PRINT "    ";INK 0;PAPER 7;"Q";PAPER 0;" ";PAPER 7;"A";PAPER 0;" ";PAPER 7;"O";PAPER 0;" ";PAPER 7;"P";PAPER 0;INK 6;" - Move"
PRINT
PRINT "    ";INK 0;PAPER 7;"M";PAPER 0;" ";PAPER 7;"SPACE";PAPER 0;INK 6;" - Turn"
PRINT
PRINT "    ";INK 0;PAPER 7;"1";PAPER 0;INK 6;" - Take, Drop"
PRINT
PRINT INK 4;"How to play:"
PRINT INK 4;"Move the fuel to Liberty Island.";
PRINT
PRINT INK 1;"Written by ZE OLIVEIRA"
PRINT INK 1;"Language: Pascalated BASIC"
PRINT INK 1;"Compiler: Boriel ZX BASIC"
PRINT INK 1;"(c) 2023 by Zarsoft"
PRINT
PRINT INK 2;"Press any key"
PAUSE 0
END PROCEDURE
  
PROCEDURE CreateSprites
VAR dest TYPE INTEGER
VAR b,c,n TYPE INTEGER
'PRINT "Creating sprites..."
LET dest = USR "A"
FOR c=1 TO 21
  REM READ cod
  FOR b=0 TO 7
    READ n
    POKE dest,n
    LET dest = dest+1
  NEXT b
  'PRINT CHR$ (143+c);" ";
NEXT c
'PAUSE 0
END PROCEDURE

PROCEDURE DataSprites
REM Liberty Statue left
REM A
DATA BIN 00111000
DATA BIN 00010000
DATA BIN 00010000
DATA BIN 00010000
DATA BIN 00010000
DATA BIN 00011000
DATA BIN 00011000
DATA BIN 00011000
REM B
DATA BIN 00011000
DATA BIN 00011011
DATA BIN 00011011
DATA BIN 00011111
DATA BIN 00011111
DATA BIN 00011111
DATA BIN 00011111
DATA BIN 00001111
REM C
DATA BIN 00001111
DATA BIN 00001111
DATA BIN 00001111
DATA BIN 00000111
DATA BIN 00000111
DATA BIN 00000111
DATA BIN 00000111
DATA BIN 00000111
REM D
DATA BIN 00000111
DATA BIN 00000111
DATA BIN 00000111
DATA BIN 00000111
DATA BIN 00000111
DATA BIN 00000111
DATA BIN 00000111
DATA BIN 00000111
REM E
DATA BIN 00000111
DATA BIN 00000111
DATA BIN 00000111
DATA BIN 00000111
DATA BIN 00001111
DATA BIN 00001111
DATA BIN 00011111
DATA BIN 00011111
REM Liberty Statue right
REM F
DATA BIN 10000000
DATA BIN 11000000
DATA BIN 11000000
DATA BIN 11000000
DATA BIN 11000000
DATA BIN 11000000
DATA BIN 11100000
DATA BIN 11110000
REM G
DATA BIN 11110000
DATA BIN 11111110
DATA BIN 11111110
DATA BIN 11111110
DATA BIN 11111100
DATA BIN 11111100
DATA BIN 11111100
DATA BIN 11111000
REM H
DATA BIN 11111000
DATA BIN 11111000
DATA BIN 11111000
DATA BIN 11111000
DATA BIN 11111000
DATA BIN 11111000
DATA BIN 11110000
DATA BIN 11110000
REM I
DATA BIN 11110000
DATA BIN 11110000
DATA BIN 11110000
DATA BIN 11110000
DATA BIN 11111000
DATA BIN 11111000
DATA BIN 11111100
DATA BIN 11111100
REM Water bike left
REM J
DATA BIN 00000000
DATA BIN 00000000
DATA BIN 00000000
DATA BIN 00000000
DATA BIN 00000000
DATA BIN 00000000
DATA BIN 00000011
DATA BIN 00000111
REM K
DATA BIN 00001111
DATA BIN 00111111
DATA BIN 01111111
DATA BIN 11111111
DATA BIN 11111111
DATA BIN 00111111
DATA BIN 00001111
DATA BIN 00000011
REM L
DATA BIN 11100000
DATA BIN 11100000
DATA BIN 11100000
DATA BIN 00111000
DATA BIN 00111100
DATA BIN 01111110
DATA BIN 11001111
DATA BIN 00001111
REM M
DATA BIN 00001110
DATA BIN 00011100
DATA BIN 00111000
DATA BIN 01110000
DATA BIN 00111000
DATA BIN 00011110
DATA BIN 00001100
DATA BIN 00011000
REM N
DATA BIN 00000000
DATA BIN 10000000
DATA BIN 11000000
DATA BIN 11100000
DATA BIN 11111110
DATA BIN 11111111
DATA BIN 11111111
DATA BIN 11111110
REM Water bike left
REM O
DATA BIN 00000000
DATA BIN 00000001
DATA BIN 00000011
DATA BIN 00000111
DATA BIN 01111111
DATA BIN 11111111
DATA BIN 11111111
DATA BIN 01111111
REM P
DATA BIN 00000111
DATA BIN 00000111
DATA BIN 00000111
DATA BIN 00011100
DATA BIN 00111100
DATA BIN 01111110
DATA BIN 11110011
DATA BIN 11110000
REM Q
DATA BIN 01110000
DATA BIN 00111000
DATA BIN 00011100
DATA BIN 00001110
DATA BIN 00011100
DATA BIN 01111000
DATA BIN 00110000
DATA BIN 00011000
REM R
DATA BIN 00000000
DATA BIN 00000000
DATA BIN 00000000
DATA BIN 00000000
DATA BIN 00000000
DATA BIN 00000000
DATA BIN 11000000
DATA BIN 11100000
REM S
DATA BIN 11110000
DATA BIN 11111100
DATA BIN 11111110
DATA BIN 11111111
DATA BIN 11111111
DATA BIN 11111100
DATA BIN 11110000
DATA BIN 11000000
REM Fuel
REM T
DATA BIN 00000000
DATA BIN 00111100
DATA BIN 01111110
DATA BIN 01111110
DATA BIN 01111110
DATA BIN 01111110
DATA BIN 01111110
DATA BIN 01111110
REM Flame
REM U
DATA BIN 00010000
DATA BIN 00011100
DATA BIN 00011110
DATA BIN 00111111
DATA BIN 01111111
DATA BIN 01111111
DATA BIN 01111111
DATA BIN 00111110
END PROCEDURE

PROCEDURE InitProgram
CreateSprites
LET MaxScore = 0
END PROCEDURE
  
BEGIN
  PAUSE 1
  PAUSE 3*50
  InitProgram
  Introduction
  InitProgram
  REPEAT
    Game
  UNTIL FALSE  
END PROGRAM
